#include <TDA7439.h>
#include <EEPROM.h>


TDA7439 myAmp;

#define pinCLK A1
#define pinDT A0
#define pinSW 7

// proměnné pro uložení pozice a stavů pro určení směru
// a stavu tlačítka
int poziceEnkod = 0;
int stavPred;
int stavCLK;
int stavSW;
int volba=2;

int hodnoty[6]={0,0,1,0,10};

bool balb=false,bb=false,sb=false,vb=false;

void nightrider() {
  for(int i=0;i<3;i++) {
    digitalWrite(A2,1);
    delay(100);
    digitalWrite(A2,0);
    digitalWrite(A3,1);
    delay(100);
    digitalWrite(A3,0); 
    digitalWrite(A4,1);
    delay(100);
    digitalWrite(A4,0);
    digitalWrite(A5,1);
    delay(100);
    digitalWrite(A5,0);
  }      
}

void setup()
{
pinMode(pinCLK,INPUT_PULLUP);//pullup zrusit
pinMode(pinDT,INPUT_PULLUP);//pullup zrusit
pinMode(pinSW,INPUT_PULLUP);
pinMode(A2,OUTPUT);digitalWrite(A2,LOW);
pinMode(A3,OUTPUT);digitalWrite(A3,LOW);
pinMode(A4,OUTPUT);digitalWrite(A4,LOW);
pinMode(A5,OUTPUT);digitalWrite(A5,LOW);
nightrider();

EEPROM.get(0, hodnoty);
myAmp.setInput(1); // 1 to 4
myAmp.inputGain(0); // 0 to 30

myAmp.setVolume(hodnoty[2]); // 0 to 48 ( 0 is mute)
myAmp.setSnd(hodnoty[3],1); // Bass-7 to +7 
myAmp.setSnd(hodnoty[1],2); // Mids -7 to +7
myAmp.setSnd(hodnoty[0],3); // Treble -7 to +7
if(hodnoty[4]>=10) {myAmp.spkAttl((hodnoty[4]-10));myAmp.spkAttr(0);} // Output attenuation 0 to 79 (db)
if(hodnoty[4]<=10) {myAmp.spkAttr((10-hodnoty[4]));myAmp.spkAttl(0);} // Output attenuation 0 to 79 (db)

// načtení aktuálního stavu pinu CLK pro porovnávání
stavPred=digitalRead(pinCLK);
}

void loop() {
  // načtení stavu pinu CLK
  stavCLK = digitalRead(pinCLK);
  // pokud je stav CLK odlišný od předchozího měření,
  // víme, že osa byla otočena
  if (stavCLK != stavPred) {
    // pokud stav pinu DT neodpovídá stavu pinu CLK,
    // byl pin CLK změněn jako první a rotace byla
    // po směru hodin, tedy vpravo
    if (digitalRead(pinDT) != stavCLK) {
      // vytištění zprávy o směru rotace a přičtení
      // hodnoty 1 u počítadla pozice enkodéru
      hodnoty[volba]=hodnoty[volba]+1;
    }
    // v opačném případě, tedy pin DT byl změněn
    // jako první, se jedná o rotaci
    // proti směru hodin, tedy vlevo
    else {
      // vytištění zprávy o směru rotace a odečtení
      // hodnoty 1 u počítadla pozice enkodéru
      hodnoty[volba]=hodnoty[volba]-1;
    }
  EEPROM.put(0, hodnoty);
  }
  
  // uložení posledního stavu pinu CLK
  // jako reference pro další porovnávání
  stavPred = stavCLK;
  // načtení stavu pinu SW - tlačítko
  stavSW = digitalRead(pinSW);
  // v případě stisknutí vytiskni informaci
  // po sériové lince
  if (stavSW == 0) {
    
    volba=volba+1;
    if(volba>4) volba=0;
    delay(500);
  }
    if(volba==0) {                   //TREBLE
      digitalWrite(A5,0);
      digitalWrite(A4,0);
      digitalWrite(A3,0);
      digitalWrite(A2,1);
      if(hodnoty[0]<(-7)) hodnoty[0]=(-7);
      if(hodnoty[0]>(7)) hodnoty[0]=(7);
      myAmp.setSnd((hodnoty[0]),3); // Treble -7 to +7
  if(hodnoty[0]==0 && vb==false) {
    for(int i=0;i<5;i++) {
      digitalWrite(A2,0);
      delay(50);
      digitalWrite(A2,1);
      delay(50);
    }
    vb=true;  
  }
  if(hodnoty[0]!=0) vb=false;
 
    }
    if(volba==1) {                   //MID
      digitalWrite(A5,0);
      digitalWrite(A4,0);
      digitalWrite(A3,1);
      digitalWrite(A2,0);
      if(hodnoty[1]<(-7)) hodnoty[1]=(-7);
      if(hodnoty[1]>(7)) hodnoty[1]=(7);
      myAmp.setSnd((hodnoty[1]),2); // Mids -7 to +7  
  if(hodnoty[1]==0 && sb==false) {
    for(int i=0;i<5;i++) {
      digitalWrite(A3,0);
      delay(50);
      digitalWrite(A3,1);
      delay(50);
    }
    sb=true;  
  }
  if(hodnoty[1]!=0) sb=false;
      
    }
    if(volba==2) {                   //VOLUME
      digitalWrite(A5,0);
      digitalWrite(A4,0);
      digitalWrite(A3,0);
      digitalWrite(A2,0);
      if(hodnoty[2]<(0)) hodnoty[2]=(0);
      if(hodnoty[2]>(48)) hodnoty[2]=(48);
      myAmp.setVolume((hodnoty[2])); // 0 to 48 ( 0 is mute)      
    }
    if(volba==3) {                   //BASS
      digitalWrite(A5,0);
      digitalWrite(A4,1);
      digitalWrite(A3,0);
      digitalWrite(A2,0);
      if(hodnoty[3]<(-7)) hodnoty[3]=(-7);
      if(hodnoty[3]>(7)) hodnoty[3]=(7);
      myAmp.setSnd((hodnoty[3]),1); // Bass-7 to +7

  if(hodnoty[3]==0 && bb==false) {
    for(int i=0;i<5;i++) {
      digitalWrite(A4,0);
      delay(50);
      digitalWrite(A4,1);
      delay(50);
    }
    bb=true;  
  }
  if(hodnoty[3]!=0) bb=false;
            
    }
    if(volba==4) {                   //BALANCE
      digitalWrite(A5,1);
      digitalWrite(A4,0);
      digitalWrite(A3,0);
      digitalWrite(A2,0);
      if(hodnoty[4]<(0)) hodnoty[4]=(0);
      if(hodnoty[4]>(20)) hodnoty[4]=(20);
      if(hodnoty[4]<=10) myAmp.spkAttr((10-hodnoty[4])); // Output attenuation 0 to 79 (db)   
      if(hodnoty[4]>=10) myAmp.spkAttl((hodnoty[4]-10)); // Output attenuation 0 to 79 (db) 

  if(hodnoty[4]==10 && balb==false) {
    for(int i=0;i<5;i++) {
      digitalWrite(A5,0);
      delay(50);
      digitalWrite(A5,1);
      delay(50);
    }
    balb=true;  
  }
  if(hodnoty[4]!=10) balb=false;
                   
    }
}
